# HaskellDO-Display

This library is meant to interface with the [HaskellDO](https://github.com/theam/haskell-do) editor.
The library provides a type Display and a type class Displayable which are menat to provide
an API to rendering media in HaskellDO.

### Example
As an example, say I wanted to add the ability to load GIFs in HaskellDO.
Firstly in the `Types.hs` file I would add:
```{haskell}
DisplayType 
  = DisplayText
  | DisplayJpg
  | DisplayPng
  | DisplayHtml
  | DisplayGif
  deriving Generic
```
This defines a valid GIF type for `Display`.
Then in `Displayable.hs` I would define a `Displayable` instance for GIFs.
```{haskell}
instance Displayable Gif where 
  display g = Display DisplayGif <path/to/gif>
```

All of this allows HaskellDO to render `GIF`s as JSON which can then be parsed by the front end and displayed down the line.